<?
/***************************************************************************
 *   Copyright (C) 2006 Artur Wiebe                                        *
 *   wibix@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once(BASEDIR."side_left.php");

require_once("include/common.php");

if(isset($_GET['view']) && $_GET['view']=="list") {
	$view = "list";
} else {
	$view = "cal";
}


/*
 * FUNCS
 */
function ec_render_cal($month, $year,
	$content, $align, $height, $show_others)
{
	global $locale;

	$today = getdate(time());
	unset($mday);
	if($today['mon']==$month && $today['year']==$year) {
		$mday = $today['mday'];
	}

	$thisday = mktime(12, 0, 0, $month, 1, $year);
	$date = getdate($thisday);

	if($date['wday']==0) {
		$date['wday'] = 7;
	}
	$offset = $date['wday'] - 1;

	/*
	 * line by line
	 */
	echo "<table class='tbl-border' cellspacing='1' width='100%'>\n";

	// days of week
	echo "<tr>";
	for($i=1; $i<=7; $i ++) {
		echo "<td width='13%' class='forum-caption'><b>"
			.$locale['EC901'][$i]."</b></td>";
	}
	echo "</tr>";

	// start with offset
	echo "<tr>\n";
	for($i=0; $i<$offset; ++$i) {
		echo "<td class='forum-caption'></td>\n";
	}
	// start month
	$col = 0;
	while($date['mon']==$month) {
		$day = $date['mday'];
		++$col;
		if(isset($content[$day])) {
			$tbl = "tbl1";
			$text = $content[$day];
		} else {
			$tbl = "tbl2";
			$text = "";
		}
		if(isset($mday) && $mday==$day) {
			$tbl = "tbl";
		}
		echo "<td class='$tbl' valign='top' height='$height'>"
			."<div style='overflow:hidden;'>"
			."<a href='".FUSION_SELF."?y=$year&amp;m=$month&amp;d=$day'>".$date['mday']."</a><br>"
			.$text
			."</div>"
			."</td>\n";

		// next day
		$thisday += 60*60*24;	// add 24 hours = 60*60*24 secs
		$date = getdate($thisday);

		// new line
		if($date['wday']==1 && $date['mon']==$month) {
			echo "</tr>\n<tr>\n";
			$col = 0;
		}
	}
	for($i=0; $i<(7-$col); $i++) {
		echo "<td class='forum-caption'></td>\n";
	}
	echo "</tr>\n";
	echo "</table>\n";
}

function ec_render_list($mday, $month, $year,
	$content, $align, $height, $show_others)
{
	global $locale;

	$thisday = mktime(12, 0, 0, $month, 1, $year);
	$date = getdate($thisday);

	if($date['wday']==0) {
		$date['wday'] = 7;
	}
	$offset = $date['wday'] - 1;

	/*
	 * line by line
	 */
	echo "<table class='tbl-border' cellspacing='1' width='100%'>\n";

	/* days of week
	echo "<tr>";
	for($i=1; $i<=7; $i ++) {
		echo "<td width='13%' class='forum-caption'><b>"
			.$locale['EC901'][$i]."</b></td>";
	}
	echo "</tr>";
	*/

	// start with offset
	for($i=0; $i<$offset; ++$i) {
		echo "<tr><td>".$locale['EC901'][$i+1]."</td><td class='forum-caption'></td></tr>\n";
	}
	// start month
	$col = 0;
	while($date['mon']==$month) {
		++$col;
		if(isset($content[$date['mday']])) {
			$tbl = "tbl1";
			$text = "<br>".$content[$date['mday']];
		} else {
			$tbl = "tbl2";
			$text = "";
		}
		echo "<tr>\n";
		echo "<td>".$locale['EC901'][$date['wday']]."</td>\n";
		echo "<td class='$tbl' valign='top' height='$height'>"
			.$date['mday'].$text."</td>\n";
		echo "</tr>\n";

		// next day
		$thisday += 60*60*24;	// add 24 hours = 60*60*24 secs
		$date = getdate($thisday);

		// new line
		if($date['wday']==1 && $date['mon']==$month) {
			$col = 0;
		}
	}
	for($i=0; $i<(7-$col); $i++) {
		echo "<tr><td class='forum-caption'></td></tr>\n";
	}
	echo "</table>\n";
}


/*
 * birthday
 */
if(ec_check_access($ec_settings['show_birthday_to_group'])) {
	opentable($locale['EC401']);

	$query_id = dbquery("SELECT user_name,"
		." DATE_FORMAT(user_birthdate, '".$ec_settings['birthday_date_format']."') AS birthday,"
		." user_id, user_avatar"
		." FROM ".DB_PREFIX."users"
		." WHERE MONTH(user_birthdate)='$ec_month'"
		." ORDER BY DAYOFMONTH(user_birthdate) ASC");
	if(!dbrows($query_id)) {
		echo "<p>".$locale['EC004'];
	} else {
		echo "<ul>\n";
	}
	while($user = dbarray($query_id)) {
/*		if($user['user_avatar']!="") {
				echo "<img src='".BASEDIR."images/avatars/"
				.$user['user_avatar']."'><br/>";
		}
*/
		echo "<li>".$user['birthday']
//			.showdate("%x", $user['birthday'])
			." <a href='".BASEDIR."profile.php?lookup=".$user['user_id']
			."'>".$user['user_name']."</a></li>\n";
	}
	if(dbrows($query_id)) {
		echo "</ul>\n";
	}

	closetable();
	tablebreak();
}



/*
 * GUI
 */
if(isset($d)) {
	$ev = ec_get_events($d, $ec_month, $ec_year, "day", "", true);
	if(isset($ev[$d])) {
		$event_id = array_shift(array_keys($ev[$d]));
		opentable($ev[$d][$event_id]['date']);

		$count = count($ev[$d]);
		foreach($ev[$d] as $id => $day_data) {
			$title = "<b>".$day_data['title']."</b>";
			$body = str_replace(EC_BREAK, "", $day_data['body']);
			if(!$day_data['no_smileys']) {
				$body = parsesmileys($event['ev_body']);
			}
//FIXME			echo "<img src='icons/event.gif' alt=''> <a href='view_event.php?id=$id'>$title</a><br>"
			echo "<a href='view_event.php?id=$id'>$title</a><br>"
				.nl2br(parseubb($body))."<br>\n";
			if(--$count) {
				echo "<hr>\n";
			}
		}
		closetable();
		tablebreak();
	}
}


// create cal-navigation
$pmonth = ($ec_month>1 ? $ec_month-1 : $ec_month);
$nmonth = ($ec_month<12 ? $ec_month+1 : $ec_month);
$pyear = $ec_year-1;
$nyear = $ec_year+1;
$cal_navi = ""
."<a href='".FUSION_SELF."?y=$pyear&amp;m=$ec_month'><img src='icons/dprev.gif' alt='' border='0'></a>"
."<a href='".FUSION_SELF."?y=$ec_year&amp;m=$pmonth'><img src='icons/prev.gif' alt='' border='0'></a>"
."<b>".$locale['EC900'][$ec_month]." <a href='browse.php?y=$ec_year'>$ec_year</a></b>"
."<a href='".FUSION_SELF."?y=$ec_year&amp;m=$nmonth'><img src='icons/next.gif' alt='' border='0'></a>"
."<a href='".FUSION_SELF."?y=$nyear&amp;m=$ec_month'><img src='icons/dnext.gif' alt='' border='0'></a>";

$sel_months = "";
for($i=1; $i<=12; ++$i) {
	$sel_months .= "<option value='$i'".($i==$ec_month ? " selected" : "").">"
		.$locale['EC900'][$i]."</option>\n";
}
$cal_navi = "\n<form method='get' action='".FUSION_SELF."'>
<select class='textbox' name='m'>$sel_months</select>
<input type='hidden' name='view' value='$view'>
<input type='text' size='4' maxlegth='4' class='textbox' name='y' value='$ec_year'>
<input type='submit' value='".$locale['EC451']."' class='button'>
</form>";


/*
 * GUI - month overview
 */
opentable($locale['EC400']);
echo ec_get_menu();
echo "<table border='0' cellspacing='0' cellpadding='0' width='100%'>
<tr>
	<td align='left' width='1%'><a href='".FUSION_SELF."?view=$view'>"
		.$locale['EC201']."</a></td>
	<td align='center'>$cal_navi</td>
	<td align='right' width='1%' style='white-space:nowrap;'><b>"
		.$locale['EC402'].":</b> "
		."<a href='".FUSION_SELF."?y=$ec_year&m=$ec_month'>"
			.$locale['EC403']."</a>"
		." | <a href='".FUSION_SELF."?y=$ec_year&m=$ec_month&amp;view=list'>"
			.$locale['EC404']."</a></td>
</tr>
</table>
<hr>\n";

$events = ec_get_events("", $ec_month, $ec_year, "day", "", false);
$content = array();

foreach($events as $day => $more) {
//FIXME	$btext = "<a href='".FUSION_SELF."?y=$year&m=$more&d=$day'>$day</a><br>";
	$btext = "";
	foreach($more as $ev_id => $day_data) {
		$title = $day_data['title'];
		$btext .= "<a href='view_event.php?id=$ev_id' title='$title'>"
			.$title."</a><br>";
//		echo "<li><a href='view_event.php?id=$ev_id'>"
//			."$title</a></li>";
	}
	$content[$day] = $btext;
}

if($view=="list") {
//	ec_render_list($mday, $month, $year, $content, "left", 80, true);
//	foreach($content as $day => $data) {
//		echo "<b>$day.</b><br>\n<ul>\n$data\n</ul>\n";
//	}
	$today = getdate(time());
	unset($mday);
	if($today['mon']==$ec_month && $today['year']==$ec_year) {
		$mday = $today['mday'];
		if(!isset($content[$mday])) {
			$content[$mday] = $locale['EC405'];
			ksort($content);
		}
	}
	echo "<table class='tbl-border' width='100%' cellspacing='1'>\n";
	foreach($content as $day => $data) {
		if(isset($mday) && $day==$mday) {
			$tbl = "tbl";
		} else {
			$tbl = "tbl2";
		}
		echo "<tr><td class='$tbl'><b>$day.</b></td></tr>\n"
			."<tr><td class='tbl1'>$data</td>\n</tr>\n";
	}
	echo "</table>\n";

} else {
	ec_render_cal($ec_month, $ec_year, $content, "left", 80, true);
}

closetable();


require_once BASEDIR."side_right.php";
require_once BASEDIR."footer.php";
?>
